]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
Merge tag 'modules-for-v5.12' of git://git.kernel.org/pub/scm/linux/kernel/git/jeyu...
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
e83b9f55 42 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
43 fi
44}
45
a8cccdd9
ST
46# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49 info GEN .tmp_initcalls.lds
50
51 ${PYTHON} ${srctree}/scripts/jobserver-exec \
52 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
53 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
54 > .tmp_initcalls.lds
55}
56
38e89184
ST
57# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61 info GEN .tmp_symversions.lds
62 rm -f .tmp_symversions.lds
63
64 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65 if [ -f ${o}.symversions ]; then
66 cat ${o}.symversions >> .tmp_symversions.lds
67 fi
68 done
69}
70
1f2bfbd0
SR
71# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
a5967db9 75 local objects
38e89184 76 local lds=""
a5967db9 77
6358d6e8 78 objects="--whole-archive \
d151e971 79 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
80 --no-whole-archive \
81 --start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 --end-group"
84
dc5723b0 85 if [ -n "${CONFIG_LTO_CLANG}" ]; then
a8cccdd9
ST
86 gen_initcalls
87 lds="-T .tmp_initcalls.lds"
88
38e89184
ST
89 if [ -n "${CONFIG_MODVERSIONS}" ]; then
90 gen_symversions
91 lds="${lds} -T .tmp_symversions.lds"
92 fi
93
dc5723b0
ST
94 # This might take a while, so indicate that we're doing
95 # an LTO link
96 info LTO ${1}
97 else
98 info LD ${1}
99 fi
100
38e89184 101 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
102}
103
6804c1af
PZ
104objtool_link()
105{
106 local objtoolopt;
107
108 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
109 objtoolopt="check"
110 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
111 objtoolopt="${objtoolopt} --no-fp"
112 fi
113 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
114 objtoolopt="${objtoolopt} --no-unreachable"
115 fi
116 if [ -n "${CONFIG_RETPOLINE}" ]; then
117 objtoolopt="${objtoolopt} --retpoline"
118 fi
119 if [ -n "${CONFIG_X86_SMAP}" ]; then
120 objtoolopt="${objtoolopt} --uaccess"
121 fi
122 info OBJTOOL ${1}
123 tools/objtool/objtool ${objtoolopt} ${1}
124 fi
125}
126
1f2bfbd0 127# Link of vmlinux
341dfcf8 128# ${1} - output file
618916a4 129# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
130vmlinux_link()
131{
132 local lds="${objtree}/${KBUILD_LDS}"
618916a4 133 local output=${1}
a5967db9 134 local objects
af73d78b 135 local strip_debug
1f2bfbd0 136
d7b0827f
LT
137 info LD ${output}
138
618916a4
AN
139 # skip output file argument
140 shift
141
af73d78b
KC
142 # The kallsyms linking does not need debug symbols included.
143 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
144 strip_debug=-Wl,--strip-debug
145 fi
146
1f2bfbd0 147 if [ "${SRCARCH}" != "um" ]; then
dc5723b0
ST
148 if [ -n "${CONFIG_LTO_CLANG}" ]; then
149 # Use vmlinux.o instead of performing the slow LTO
150 # link again.
151 objects="--whole-archive \
152 vmlinux.o \
153 --no-whole-archive \
154 ${@}"
155 else
156 objects="--whole-archive \
157 ${KBUILD_VMLINUX_OBJS} \
158 --no-whole-archive \
159 --start-group \
160 ${KBUILD_VMLINUX_LIBS} \
161 --end-group \
162 ${@}"
163 fi
a5967db9 164
618916a4 165 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
af73d78b 166 ${strip_debug#-Wl,} \
618916a4 167 -o ${output} \
a5967db9 168 -T ${lds} ${objects}
1f2bfbd0 169 else
6358d6e8 170 objects="-Wl,--whole-archive \
d151e971 171 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
172 -Wl,--no-whole-archive \
173 -Wl,--start-group \
174 ${KBUILD_VMLINUX_LIBS} \
175 -Wl,--end-group \
618916a4 176 ${@}"
a5967db9 177
618916a4 178 ${CC} ${CFLAGS_vmlinux} \
af73d78b 179 ${strip_debug} \
618916a4 180 -o ${output} \
6358d6e8
NP
181 -Wl,-T,${lds} \
182 ${objects} \
a5967db9 183 -lutil -lrt -lpthread
1f2bfbd0
SR
184 rm -f linux
185 fi
186}
187
e83b9f55 188# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
189# ${1} - vmlinux image
190# ${2} - file to dump raw BTF data into
e83b9f55
AN
191gen_btf()
192{
341dfcf8 193 local pahole_ver
e83b9f55 194
581b31c3 195 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 196 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 197 return 1
581b31c3
AN
198 fi
199
e83b9f55 200 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
201 if [ "${pahole_ver}" -lt "116" ]; then
202 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 203 return 1
e83b9f55
AN
204 fi
205
341dfcf8 206 vmlinux_link ${1}
af73d78b
KC
207
208 info "BTF" ${2}
e83b9f55 209 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
341dfcf8 210
90ceddcb
FS
211 # Create ${2} which contains just .BTF section but no symbols. Add
212 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
213 # deletes all symbols including __start_BTF and __stop_BTF, which will
214 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
215 # objcopy warnings: "empty loadable segment detected at ..."
216 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
217 --strip-all ${1} ${2} 2>/dev/null
218 # Change e_type to ET_REL so that it can be used to link final vmlinux.
219 # Unlike GNU ld, lld does not allow an ET_EXEC input.
220 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 221}
1f2bfbd0 222
08beb669 223# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
224kallsyms()
225{
1f2bfbd0
SR
226 local kallsymopt;
227
228 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 229 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
230 fi
231
4d5d5664 232 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
233 kallsymopt="${kallsymopt} --absolute-percpu"
234 fi
235
2213e9a6
AB
236 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
237 kallsymopt="${kallsymopt} --base-relative"
238 fi
239
08beb669
MY
240 info KSYMS ${2}
241 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
242}
243
8959e392
KC
244# Perform one step in kallsyms generation, including temporary linking of
245# vmlinux.
246kallsyms_step()
247{
248 kallsymso_prev=${kallsymso}
af73d78b
KC
249 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
250 kallsymso=${kallsyms_vmlinux}.o
08beb669 251 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 252
d7b0827f 253 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
254 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
255
256 info AS ${kallsyms_S}
257 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
258 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
259 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
260}
261
1f2bfbd0
SR
262# Create map file with all symbols from ${1}
263# See mksymap for additional details
264mksysmap()
265{
266 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
267}
268
10916706 269sorttable()
1347a2ce 270{
10916706 271 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
272}
273
1f2bfbd0 274# Delete output files in case of error
1f2bfbd0
SR
275cleanup()
276{
341dfcf8 277 rm -f .btf.*
1f2bfbd0 278 rm -f .tmp_System.map
a8cccdd9 279 rm -f .tmp_initcalls.lds
38e89184 280 rm -f .tmp_symversions.lds
1f2bfbd0
SR
281 rm -f .tmp_vmlinux*
282 rm -f System.map
283 rm -f vmlinux
284 rm -f vmlinux.o
285}
286
ab160dbb
SB
287on_exit()
288{
289 if [ $? -ne 0 ]; then
290 cleanup
291 fi
292}
293trap on_exit EXIT
294
295on_signals()
296{
297 exit 1
298}
299trap on_signals HUP INT QUIT TERM
300
1f2bfbd0
SR
301# Use "make V=1" to debug this script
302case "${KBUILD_VERBOSE}" in
303*1*)
304 set -x
305 ;;
306esac
307
308if [ "$1" = "clean" ]; then
309 cleanup
310 exit 0
311fi
312
313# We need access to CONFIG_ symbols
94cf8acc 314. include/config/auto.conf
1f2bfbd0 315
1f2bfbd0
SR
316# Update version
317info GEN .version
278ae604
MY
318if [ -r .version ]; then
319 VERSION=$(expr 0$(cat .version) + 1)
320 echo $VERSION > .version
1f2bfbd0 321else
278ae604
MY
322 rm -f .version
323 echo 1 > .version
1f2bfbd0
SR
324fi;
325
326# final build of init/
083bc0e1 327${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 328
abac4c89 329#link vmlinux.o
abac4c89 330modpost_link vmlinux.o
6804c1af 331objtool_link vmlinux.o
abac4c89
NP
332
333# modpost vmlinux.o to check for section mismatches
a721588d 334${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 335
898490c0
AG
336info MODINFO modules.builtin.modinfo
337${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
338info GEN modules.builtin
339# The second line aids cases where multiple modules share the same object.
340tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
341 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 342
7fd78568 343btf_vmlinux_bin_o=""
341dfcf8 344if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
345 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
346 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
347 echo >&2 "Failed to generate BTF for vmlinux"
348 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
349 exit 1
341dfcf8
AN
350 fi
351fi
352
1f2bfbd0 353kallsymso=""
8959e392 354kallsymso_prev=""
1f2bfbd0
SR
355kallsyms_vmlinux=""
356if [ -n "${CONFIG_KALLSYMS}" ]; then
357
358 # kallsyms support
359 # Generate section listing all symbols and add it into vmlinux
360 # It's a three step process:
361 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
362 # but __kallsyms is empty.
363 # Running kallsyms on that gives us .tmp_kallsyms1.o with
364 # the right size
365 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
366 # the right size, but due to the added section, some
367 # addresses have shifted.
368 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
369 # 3) That link may have expanded the kernel image enough that
370 # more linker branch stubs / trampolines had to be added, which
371 # introduces new names, which further expands kallsyms. Do another
372 # pass if that is the case. In theory it's possible this results
373 # in even more stubs, but unlikely.
374 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
375 # other bugs.
376 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
377 #
378 # a) Verify that the System.map from vmlinux matches the map from
379 # ${kallsymso}.
380
8959e392
KC
381 kallsyms_step 1
382 kallsyms_step 2
1f2bfbd0 383
7e2b37c9 384 # step 3
8959e392
KC
385 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
386 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
387
388 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 389 kallsyms_step 3
1f2bfbd0
SR
390 fi
391fi
392
d7b0827f 393vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 394
c9a0f3b8 395# fill in BTF IDs
017dab34
JO
396if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
397 info BTFIDS vmlinux
398 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
399fi
400
10916706
SZ
401if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
402 info SORTTAB vmlinux
f14bf6a3
SZ
403 if ! sorttable vmlinux; then
404 echo >&2 Failed to sort kernel tables
405 exit 1
406 fi
1347a2ce
LT
407fi
408
1f2bfbd0
SR
409info SYSMAP System.map
410mksysmap vmlinux System.map
411
412# step a (see comment above)
413if [ -n "${CONFIG_KALLSYMS}" ]; then
414 mksysmap ${kallsyms_vmlinux} .tmp_System.map
415
416 if ! cmp -s System.map .tmp_System.map; then
5369f550 417 echo >&2 Inconsistent kallsyms data
367e43c5 418 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
419 exit 1
420 fi
421fi